function [StitchedMesh]=StitchMesh(fmesh,f,v,patchgroup,centers,candidates)
threshold=0.3;
for i=1:size(fmesh,2)
    spine_v=f(fmesh{i},:);
    spine_v=unique(spine_v(:));
    spine_p=v(spine_v(:),:);
    spinecenters(i,:)=mean(spine_p(:,1:2));
end

for i=1:size(spinecenters,1)
    rpt_v=repmat(spinecenters(i,:),size(centers,1),1);
    temp=dot((rpt_v-centers),(rpt_v-centers),2);
    [mini,mini_ind]=min(temp);
    disinds(i,1)=mini_ind(1);
end
n=1;
for i=1:size(patchgroup,2)
    if size(patchgroup{i},1)==1
        spine1_f=f(fmesh{patchgroup{i}(1)},:);
        spine1_v=v(spine1_f(:),:);
        
        spine2_f=f(fmesh{patchgroup{i}(2)},:);
        spine2_v=v(spine2_f(:),:);
     
        k1 = convhull(spine1_v(:,1),spine1_v(:,2));
        k2 = convhull(spine2_v(:,1),spine2_v(:,2));
        in1 = inhull(spine2_v(:,1:2),spine1_v(k1,1:2));
        rate1=size(find(in1==1),1)/size(spine2_v,1);
        in2 = inhull(spine1_v(:,1:2),spine2_v(k2,1:2));
        rate2=size(find(in2==1),2)/size(spine1_v,1);
%         if rate1>rate2
%             rate(i)=rate1;
%         else
%             rate(i)=rate2;
%         end
        rate(i)=(rate1+rate2)/2;
        %rate(i)=rate(i)-distance(centers(disinds(patchgroup{i}(1)),:),centers(disinds(patchgroup{i}(2)),:));
        if rate(i)>threshold
            StitchedMesh{n}=union(fmesh{patchgroup{i}(1)},fmesh{patchgroup{i}(2)});
            n=n+1;
        else
            StitchedMesh{n}=fmesh{patchgroup{i}(1)};
            n=n+1;
            StitchedMesh{n}=fmesh{patchgroup{i}(2)};
            n=n+1;
        end
        
%         temp=union(fmesh{patchgroup{i}(1)},fmesh{patchgroup{i}(2)});
%         spine_v=f(temp,:);
%         spine_v=unique(spine_v(:));
%         spine_p=v(spine_v(:),:);
%         spinecenter=mean(spine_p(:,1:2));
%         
%         rpt_v=repmat(spinecenter,size(centers,1),1);
%         temp=dot((rpt_v-centers),(rpt_v-centers),2);
%         [mini,mini_ind]=min(temp);
%         disind=mini_ind(1);
%         temp=(distance(centers(disinds(patchgroup{i}(1)),:),centers(disind,:))+distance(centers(disinds(patchgroup{i}(2)),:),centers(disind,:)))/distance(centers(disinds(patchgroup{i}(2)),:),centers(disinds(patchgroup{i}(1)),:));
%         if ~isnan(temp)
%             %  rate(i)=rate(i)-temp;
%         end

    else
        %ind=unique();
        ind=unique(patchgroup{i}(:));
        sim=SimMat(f,v,patchgroup{i},fmesh);
        smesh=stitch(sim, fmesh,ind,f,v);
        for k=1:size(smesh,2)
            StitchedMesh{n}=smesh{k};
            n=n+1;
        end 
    end 
end
ind=unique(candidates(:));
ind=setdiff(1:size(fmesh,2),ind);
for i=1:size(ind,2)
    StitchedMesh{n}=fmesh{ind(i)};
    n=n+1;
end


end