cd C:\Users\Qing\Research\SphericalWavelets\SpineDetection_Code
addpath C:\Users\Qing\Research\SphericalWavelets\SpineDetection_Code\NCut
addpath C:\Users\Qing\Research\SphericalWavelets\SpineDetection_Code\Imgs
% 
%read a image
im = read3dtiff;


% extract backbone
close all;
[centers, radius]=medialaxis(im); %select a seed point on the backbone(medial axis)

%reconstruct 3d surface
%im=medfilt_3D(im); %medial filter

[f,n,v]=reconstruct(im,25);
[f,v,n]=reduce(im,f,v,4500/size(f,1));

%generate score map
v_neighbors=neighborsofv(f,size(v,1));
[dis,disind,v2center_vector]=ComputeDistance(v,centers);
angle=variation_normal(n,v2center_vector);
score=dis+angle;
color=generatecolormap(jet,score);
visualize_color(f,v,color);
fscore=scoreperface(f,score);

%separate spiens from dendrite
Tmesh=RegionGrowing_f(fscore,f,360,v);
color=mesh_f_color(Tmesh,v,f);
visualize_color(f,v,color);
[single,touching]=checktouchingspine(Tmesh,f,v,angle,n);

%Normalized cut to separate touching spines
matrix=generate_similarity_matrix(f,v);
[NcutDiscrete,NcutEigenvectors,NcutEigenvalues] = ncutW(matrix,130);
SegLabel = zeros(size(matrix,1),1);
for j=1:size(NcutDiscrete,2),
    SegLabel = SegLabel + j*NcutDiscrete(:,j);
end
Nmesh=labeltomesh(SegLabel);
Nmesh=sort_spines(Nmesh,f,v);
color=mesh_f_color(Nmesh,v,f);
visualize_color(f,v,color);
Imesh=intersect_f(touching,Nmesh);
 
%stitch patches
[boundary,rings,sim,candidates]=similaritybetmesh(Imesh,f,v);
patchgroup=group_candidate(candidates);
StitchedMesh=StitchMesh(Imesh,f,v,patchgroup,centers(:,1:2),candidates);
num1=size(Imesh,2);
num2=size(StitchedMesh,2);
while (num2<num1)
    Imesh=StitchedMesh;
    [boundary,rings,sim,candidates]=similaritybetmesh(Imesh,f,v);
    patchgroup=group_candidate(candidates);
    StitchedMesh=StitchMesh(Imesh,f,v,patchgroup,centers(:,1:2),candidates);
    num1=num2;
    num2=size(StitchedMesh,2);
end

%final result
Finalmesh=combine(StitchedMesh,single);
Finalmesh=sort_spines(Finalmesh,f,v);
color=mesh_f_color(Finalmesh,v,f);
visualize_color(f,v,color);