function [center, NextCenter, radius, orientation]=ray1(im,x0,y0,threshold,windowsize, direction,globaldir)

% figure,imshow(im,[]);
% hold on,
% plot(51,51,'*r');

%x0,y0 coordinates in the whole image;
%rays always cast from the center.
SampleRate=3;
StartAngle=0;
EndAngle=360;
linenum=1;
points=[];
angles=[];
for angle=StartAngle:SampleRate:EndAngle
    
    kx=1;
    ky=tan(angle/180*pi); 
    
    
    if(angle>85&&angle<95)
        kx=0;
        ky=1;
    end
    
    linex=[];
    liney=[];
    flag=0;
    for t=0:50
        wx=kx*t;
        wy=ky*t;
        
   %transform the coordinates from world to image system
       y=wx+windowsize+1;
       x=windowsize+1-wy;
       
        
        
       if((round(x)<size(im,1)&&round(x)>0)&&(round(y)<size(im,2)&&round(y)>0))
           
           if (im(round(x),round(y))<threshold||abs(y)<6||(abs(size(im,2)-y)<6)||abs(x)<6||(abs(size(im,1)-x)<6))
                linex=cat(2,linex,x);
                liney=cat(2,liney,y);
                points=cat(1,points,[x,y]);
                angles=cat(1,angles,angle);
                flag=1;
                %%%%%%detect the edge point
                break;
           end
       end
        
    end
    
    if(~flag)
        points=cat(1,points,[-inf,inf]);
        angles=cat(1,angles,angle);
        linex=cat(2,linex,51);
        liney=cat(2,liney,51);
    end
    
    flag=0;
    for t=0:-1:-50
        wx=kx*t;
        wy=ky*t;
   %transform the coordinates from world to image system
       y=wx+windowsize+1;
       x=windowsize+1-wy;

        
        
       if((round(x)<size(im,1)&&round(x)>0)&&(round(y)<size(im,2)&&round(y)>0))
          
          if (im(round(x),round(y))<threshold||round(abs(y))<6||(abs(size(im,2)-round(y))<6)||(abs(size(im,1)-x)<6)||abs(x)<6)
               
                linex=cat(2,linex,x);
                liney=cat(2,liney,y);
                points=cat(1,points,[x,y]);
                angles=cat(1,angles,angle);
                flag=1;
                break;
           end
       end
        
    end
    if(~flag)
        points=cat(1,points,[-inf,inf]);
        angles=cat(1,angles,angle);
        linex=cat(2,linex,51);
        liney=cat(2,liney,51);
    end
    
    
%     hold on; h=plot(liney,linex);
%     set(h,'linewidth',1.3);
    lines(2*linenum-1:2*linenum,1)=liney;
    lines(2*linenum-1:2*linenum,2)=linex;
    
    linenum=linenum+1;
end
% plot(51,51,'*r');


dis=[];
for i=1:size(points,1)/2
    dis(i)=mydistance(points(i*2-1,:),points(i*2,:));
end

ind=find(dis==min(dis));

if(isempty(ind))
    center=[];
    NextCenter=[];
    radius=[];
    orientation=[];
    return;
end
ind=ind(1);
radius=min(dis)/2;
center=points(2*ind-1,:)+1/2*(points(2*ind,:)-points(2*ind-1,:));  
% % figure,imshow(im,[]);
% % hold on,plot(points(2*ind-1:2*ind,2),points(2*ind-1:2*ind,1));
% % hold on,plot(center(2),center(1),'*g');
angle=angles(2*ind);

%%%distance from the center to the edge
dis=[];
if(direction==1)
    for i=1:size(points,1)/2
        if(angles(2*i)<90)
            dis(i)=mydistance(lines(i*2-1,:),size(im)/2);
        else
            dis(i)=mydistance(lines(i*2,:),size(im)/2);
        end
    end
else
    for i=1:size(points,1)/2
        if(angles(2*i)<90)
            dis(i)=mydistance(size(im)/2,points(i*2,:));
        else
            dis(i)=mydistance(points(i*2-1,:),size(im)/2);
        end
    end
end



ind=find(dis==inf);
dis(ind)=0;
ind=find(dis==max(dis));
ind=ind(1);
orientation=angles(2*ind);
% liney=lines(2*ind-1:2*ind,1);
% linex=lines(2*ind-1:2*ind,2);
% hold on;
% h=plot(liney,linex,'r');

ind1=find(globaldir<90);
ind2=find(globaldir>90);
if orientation>=0 && orientation<=9
    if size(ind1,2)<size(ind2,2)&&direction==1
        orientation=180-orientation;
    end
    if size(ind1,2)>size(ind2,2)&&direction==2
        orientation=180-orientation;
    end
end
if orientation>=171 && orientation<=180
    if size(ind1,2)<size(ind2,2)&&direction==2
        orientation=180-orientation;
    end
     if size(ind1,2)>size(ind2,2)&&direction==1
        orientation=180-orientation;
    end
end



%in image plane
stepsize=5;
if(direction==1)

     if orientation>90
         NextCenter(1)=center(1)-stepsize*sin(orientation/180*pi);
         NextCenter(2)=center(2)+stepsize*cos(orientation/180*pi);
     else
         NextCenter(1)=center(1)+stepsize*sin(orientation/180*pi);
         NextCenter(2)=center(2)+stepsize*cos(orientation/180*pi);
     end
else
      if orientation >90
          NextCenter(1)=center(1)-stepsize*sin((orientation+180)/180*pi);
          NextCenter(2)=center(2)+stepsize*cos((orientation+180)/180*pi);
      else
          NextCenter(1)=center(1)+stepsize*sin(orientation/180*pi);
         NextCenter(2)=center(2)+stepsize*cos(orientation/180*pi);
      end 
end
% hold on, plot(NextCenter(2),NextCenter(1),'g*');


%to the whole image
center=center-ceil(size(im)/2)+[x0,y0];
NextCenter=NextCenter-ceil(size(im)/2)+[x0,y0];

% pause;
% close;



















