function X = read3dtiff;
% read a 3D TIFF image stack, put result in matrix X

%[filename, pathname, filterindex] = uigetfile('*.tif', 'Choose a TIFF file');
[filename, pathname] = uigetfile('*.tif', 'Choose a TIFF file');
filename = strcat(pathname, filename);
[Img,Map] = imread(filename, 'tiff');
[Ix,Iy,Iz] = size(Img);%image width,image height
h = waitbar(0,'Opening TIFF image...', 'Name', 'Opening image', 'Pointer', 'watch');
frames = length(imfinfo(filename));
X = zeros(Ix, Iy, frames,'uint8');

for i = 1:frames
    waitbar(i/frames,h, ['Loading frame ' num2str(i)]);
    X(:,:,i) = imread(filename, i);      
    %str = strcat('APP rat red tag 2DT2_', num2str(i), '.tif');
    %imagesc(b);
    %imwrite(uint16(b), str, 'tiff');
end
waitbar(1,h, 'Done');
close(h);
%clear h i Map Img
