function stitchedmesh=stitch(MatsSim, mesh,ids,f,vertex)

[M, N] = size(MatsSim);

%construct the Maxtrix A
K = 0;
for i = 1:M %%each cell in the previous frame
    %find its possible matching cells in the next frame
    Nei = find(MatsSim(i,:)>0);
    Len = length(Nei);
    if Len >= 1
       for j = 1:Len
            tag = Nei(j);
            val = -MatsSim(i,tag)/2;
            K = K + 1;
            A(K, i) = val;
            C(K, i) = i;
            A(K, M+tag) = val;
            C(K, M+tag) = tag;
        end
    end
end
    
%construct matrix B
B = zeros(size(A));
Ind = find(A<0);
B(Ind) = 1;

%step2. Optimization process using LP based Brach and bound method
F = sum(A, 2); %%%maximu(F) = minimum(-F);
B = B';
v = ones(size(B, 1), 1);
x = bintprog(F,B,v);

%%%map the solution x to the matching matrix
matchMat = false(size(MatsSim));
Ind = find(x>0);
if length(Ind) < 1
    return;
else
    for i = 1:length(Ind)
        tag = Ind(i);
        indext = C(tag,:);
        Tags = find(indext > 0);
        if length(Tags) < 2 
            continue;
        else
            tag1 = indext(Tags(1));
            tag2 = indext(Tags(2));
            matchMat(tag1, tag2) = 1;
        end
    end
end

flag=zeros([size(mesh,2),2]);
n=0;
pairs=[];
for i=1:size(matchMat,1)
    ind=find(matchMat(i,:)==1);
    if ~isempty(ind)
        for j=1:size(ind,2)
            if isempty(intersect([ind(j),i],pairs,'rows'))
                if flag(ind(j),1)==0&&flag(i,1)==0
                    n=n+1;
                    flag(ind(j),1)=1;
                    flag(ind(j),2)=n;
                    flag(i,1)=1;
                    flag(i,2)=n;
                    stitchedmesh{n}=union(mesh{i},mesh{ind(j)});
                    pairs=cat(1,pairs,[i,ind(j)]);
                else
                    if flag(i,1)==1
                        if canbestitch(f,vertex,stitchedmesh{flag(i,2)},mesh{ind(j)});
                            stitchedmesh{flag(i,2)}=union(stitchedmesh{flag(i,2)},mesh{ind(j)});
                            flag(ind(j),1)=1;
                            flag(ind(j),2)=flag(i,2);
                        else
                            n=n+1;
                            stitchedmesh{n}=mesh{ind(j)};
                            flag(ind(j),1)=1;
                            flag(ind(j),2)=n;
                        end
                    else
                        if canbestitch(f,vertex,stitchedmesh{flag(ind(j),2)},mesh{i});
                            stitchedmesh{flag(ind(j),2)}=union(mesh{i},stitchedmesh{flag(ind(j),2)});
                            flag(i,1)=1;
                            flag(i,2)=flag(ind(j),2);
                        else
                            n=n+1;
                            stitchedmesh{n}=mesh{i};
                            flag(i,1)=1;
                            flag(i,2)=n;
                        end
                    end
                    pairs=cat(1,pairs,[i,ind(j)]);
                end
            end
        end
    end
end

ind=find(flag(:,1)==0);
ind=intersect(ind,ids);
flag=0;
for i=1:size(ind,1)
    for j=1:size(stitchedmesh,2)
        if canbestitch(f,vertex,stitchedmesh{j},mesh{ind(i)})
            stitchedmesh{j}=union(stitchedmesh{j},mesh{ind(i)});
            flag=1;
            break;
        end
    end
    if ~flag
        n=n+1;
        stitchedmesh{n}=mesh{ind(i)};
    end
    
end



end




